## START: Set by rpmautospec
## (rpmautospec version 0.7.2)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%if 0%{?el8}
%undefine __cmake_in_source_build
%undefine _cmake_skip_rpath
%endif

Name:           nextcloud-client
Version:        3.13.4
Release:        %autorelease.inferit
Summary:        The Nextcloud Client

# -libs are LGPLv2+, rest GPLv2
# Automatically converted from old format: LGPLv2+ and GPLv2 - review is highly recommended.
License:        LicenseRef-Callaway-LGPLv2+ AND GPL-2.0-only
Url:            https://nextcloud.com/install/#install-clients
Source0:        https://github.com/nextcloud/desktop/archive/v%{version}/desktop-%{version}.tar.gz
Source1:        com.nextcloud.desktopclient.nextcloud.metainfo.xml

%if 0%{?fedora} >= 39
ExcludeArch:    %{ix86}
%endif

%if 0%{?rhel}
BuildRequires:  rpmautospec-rpm-macros
BuildRequires:  policycoreutils
%endif

BuildRequires:  check
BuildRequires:  chrpath
BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  doxygen
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  inotify-tools-devel
BuildRequires:  libcloudproviders-devel
BuildRequires:  libappstream-glib
BuildRequires:  neon-devel
BuildRequires:  openssl-devel
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  python3-sphinx
BuildRequires:  qtlockedfile-qt5-devel
BuildRequires:  qtkeychain-qt5-devel
BuildRequires:  qtsingleapplication-qt5-devel
BuildRequires:  qt5-qtbase
BuildRequires:  qt5-qtbase-devel
BuildRequires:  qt5-qtbase-private-devel
BuildRequires:  qt5-qtbase-gui
BuildRequires:  qt5-qtwebkit-devel
BuildRequires:  qt5-qtxmlpatterns-devel
BuildRequires:  qt5-qttools
BuildRequires:  qt5-qttools-devel
BuildRequires:  qt5-qtquickcontrols2-devel
BuildRequires:  qt5-qtwebengine-devel
BuildRequires:  qt5-qtwebsockets-devel
BuildRequires:  qt5-qtsvg-devel
BuildRequires:  extra-cmake-modules
BuildRequires:  inkscape
# Plasma 5 Dolphin integration
%if 0%{?fedora} >= 40 || 0%{?rhel} > 9
BuildRequires:  qt6-qtbase-devel
BuildRequires:  kf6-kio-devel
BuildRequires:  kf5-karchive-devel
BuildRequires:  kf6-kcoreaddons-devel
BuildRequires:  kf6-rpm-macros
%else
BuildRequires:  kf5-kio-devel
BuildRequires:  kf5-karchive-devel
BuildRequires:  kf5-kcoreaddons-devel
BuildRequires:  kf5-rpm-macros
%endif
BuildRequires:  sqlite-devel
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
%if 0%{?fedora} && 0%{?fedora} < 33
# concerning libgnome-keyring read https://bugzilla.redhat.com/show_bug.cgi?id=1652973
Requires:       libgnome-keyring
%endif
Requires:       qt5-qtquickcontrols

Provides: mirall = %{version}-%{release}
Obsoletes: mirall < 1.8.0

# Read https://bugzilla.redhat.com/show_bug.cgi?id=1651261
ExcludeArch: ppc64 ppc64le s390x

%description
Nextcloud-client enables you to connect to your private Nextcloud Server.
With it you can create folders in your home directory, and keep the contents
of those folders synced with your Nextcloud server. Simply copy a file into
the directory and the Nextcloud Client does the rest.


%package libs
Summary: Common files for nextcloud-client
# Automatically converted from old format: LGPLv2+ - review is highly recommended.
License: LicenseRef-Callaway-LGPLv2+
Provides: mirall-common = %{version}-%{release}
Obsoletes: mirall-common < 1.8.0
Requires: %{name}%{?_isa} = %{version}-%{release}

%description libs
Provides common files for nextcloud-client such as the
configuration file that determines the excluded files in a sync.


%package devel
Summary: Development files for nextcloud-client
# Automatically converted from old format: LGPLv2+ - review is highly recommended.
License: LicenseRef-Callaway-LGPLv2+
Requires: %{name}-libs%{?_isa} = %{version}-%{release}
Requires: %{name}%{?_isa} = %{version}-%{release}
Provides: %{name}-static = %{version}-%{release}
Provides: mirall-devel = %{version}-%{release}
Obsoletes: mirall-devel < 1.8.0

%description devel
Development headers for use of the nextcloud-client library

%package nautilus
Summary: nextcloud client nautilus extension
Supplements: (nextcloud-client and nautilus)
Requires: nautilus
Requires: nautilus-python
Requires: %{name}%{?_isa} = %{version}-%{release}
Provides: mirall-nautilus = %{version}-%{release}
Obsoletes: mirall-nautilus < 1.8.0

%description nautilus
The nextcloud desktop client nautilus extension.

%if 0%{?fedora}
# Only Fedora has Cinnamon, so there is no need for Nemo extension on EPEL
%package nemo
Summary:        Nemo overlay icons
Supplements:    (nextcloud-client and nemo)
Requires:       nemo
Requires:       nemo-python
Requires: %{name}%{?_isa} = %{version}-%{release}

%description nemo
This package provides overlay icons to visualize the sync state
in the nemo file manager.

# Only Fedora has Mate, so there is no need for Caja extension on EPEL
%package caja
Summary:        Caja overlay icons
Supplements:    (nextcloud-client and caja)
Requires:       caja
Requires:       python3-caja
Requires: %{name}%{?_isa} = %{version}-%{release}

%description caja
This package provides overlay icons to visualize the sync state
in the caja file manager.
%endif

%if 0%{?fedora} || 0%{?rhel} > 7
%package dolphin
Summary:        Dolphin overlay icons
Supplements:    (nextcloud-client and dolphin)
Requires:       dolphin
Requires: %{name}%{?_isa} = %{version}-%{release}

%description dolphin
The nextcloud desktop client dolphin extension.
%endif

%prep
%setup -n desktop-%{version}

# change compiler flag
sed -i 's/-fPIE/-fPIC/g' src/gui/CMakeLists.txt
sed -i 's/-fPIE/-fPIC/g' src/cmd/CMakeLists.txt

%build
%cmake_kf5 \
  -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed" \
  -DNO_SHIBBOLETH=1 \
  -DBUILD_UPDATER=False

%cmake_build

%install
%cmake_install

%if 0%{?fedora} >= 40 || 0%{?rhel} > 9
# move dolphin plugins to kf5_plugindir
mkdir -p %{buildroot}%{_kf6_plugindir}
mv -v %{buildroot}%{_qt5_plugindir}/kf6/kfileitemaction %{buildroot}/%{_kf6_plugindir}
mv -v %{buildroot}%{_qt5_plugindir}/kf6/overlayicon/ %{buildroot}/%{_kf6_plugindir}
%endif

%find_lang client --with-qt
mkdir -p %{buildroot}%{_datadir}/metainfo/
install -pm 644 %{SOURCE1} %{buildroot}%{_datadir}/metainfo/com.nextcloud.desktopclient.nextcloud.metainfo.xml


# for distros that do not have KDE Plasma 5
%if 0%{?fedora} < 24 && 0%{?rhel} <= 7
rm -f %{buildroot}%{_libdir}/libnextclouddolphinpluginhelper.so
rm -f %{buildroot}%{_kf5_plugindir}/overlayicon/nextclouddolphinoverlayplugin.so
rm -f %{buildroot}%{_qt5_plugindir}/nextclouddolphinactionplugin.so
rm -f %{buildroot}%{_kf5_datadir}/kservices5/nextclouddolphinactionplugin.desktop
%endif


%if 0%{?rhel}
# Only Fedora has Cinnamon, so there is no need for Nemo extension on EPEL
rm -rf %{buildroot}%{_datadir}/nemo-python/
# Only Fedora has Mate, so there is no need for Caja extension on EPEL
rm -rf %{buildroot}%{_datadir}/caja-python/
%endif

%post
%if 0%{?rhel}
setsebool -P selinuxuser_execmod=on
%endif

%postun
%if 0%{?rhel}
setsebool -P selinuxuser_execmod=off
%endif

%check
appstream-util validate-relax --nonet %{buildroot}%{_datadir}/metainfo/com.nextcloud.desktopclient.nextcloud.metainfo.xml

%ldconfig_scriptlets libs

%if 0%{?fedora} >= 24 || 0%{?rhel} > 7
%ldconfig_scriptlets dolphin
%endif

%files -f client.lang
%{_bindir}/nextcloud
%{_bindir}/nextcloudcmd
%{_datadir}/mime/packages/nextcloud.xml
%{_datadir}/applications/com.nextcloud.desktopclient.nextcloud.desktop
%{_datadir}/icons/hicolor/*/apps/*
%{_datadir}/metainfo/com.nextcloud.desktopclient.nextcloud.metainfo.xml
%{_datadir}/dbus-1/services/com.nextcloudgmbh.Nextcloud.service
%{_datadir}/cloud-providers/com.nextcloudgmbh.Nextcloud.ini

%files libs
%{_libdir}/libnextcloudsync.so.0
%{_libdir}/libnextcloudsync.so.%{version}
%{_libdir}/libnextcloud_csync.so*
%doc README.md
%config %{_sysconfdir}/Nextcloud/sync-exclude.lst
%dir %{_sysconfdir}/Nextcloud

%files devel
%{_includedir}/nextcloudsync/
%{_libdir}/libnextcloudsync.so
%{_libdir}/nextcloudsync_vfs_suffix.so
%{_libdir}/nextcloudsync_vfs_xattr.so

%files nautilus
%{_datadir}/nautilus-python/extensions/*

%if 0%{?fedora}
# Only Fedora has Cinnamon, so there is no need for Nemo extension on EPEL
%files nemo
%{_datadir}/nemo-python/extensions/*

# Only Fedora has Mate, so there is no need for Caja extension on EPEL
%files caja
%{_datadir}/caja-python/extensions/*
%endif

%files dolphin
%{_libdir}/libnextclouddolphinpluginhelper.so
%if 0%{?fedora} >= 40 || 0%{?rhel} > 9
%{_kf6_plugindir}/overlayicon/nextclouddolphinoverlayplugin.so
%{_kf6_plugindir}/kfileitemaction/nextclouddolphinactionplugin.so
%else
%{_kf5_plugindir}/overlayicon/nextclouddolphinoverlayplugin.so
%{_kf5_plugindir}/kfileitemaction/nextclouddolphinactionplugin.so
%endif

%changelog
* Mon Sep 16 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.13.4-2
- RPMAUTOSPEC: unresolvable merge

* Mon Sep 02 2024 Eduard Basov <ebasov@msvsphere-os.ru> - 3.13.2-1
- Rebuilt for MSVSphere 9.4

* Sat Jul 13 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.13.2-1
- Update to v3.13.2

* Fri Jul 05 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.13.1-3
- Add openssl-devel-engine as BR; close #rhbz 2295633

* Fri Jul 05 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.13.1-2
- Update to v3.13.1; close #rhbz 2295633

* Fri Jul 05 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.13.1-1
- Update to v3.13.1; close #rhbz 2295633

* Thu May 23 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.13.0-1
- Update to v3.13.0

* Thu May 09 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.12.5-1
- Update to v3.12.5

* Sat Mar 30 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.12.3-1
- Update to v3.12.3

* Sat Mar 09 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.12.1-1
- Update to v3.12.1

* Sat Jan 27 2024 Mukundan Ragavan <nonamedotc@gmail.com> - 3.11.1-1

- Update to v3.11.1

* Thu Jan 25 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.11.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 3.11.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Thu Dec 14 2023 Mukundan Ragavan <nonamedotc@gmail.com> - 3.11.0-1
- Update to v3.11.0

* Thu Nov 16 2023 Mukundan Ragavan <nonamedotc@gmail.com> - 3.10.1-1
- Update to v3.10.1

* Tue Oct 17 2023 Mukundan Ragavan <nonamedotc@gmail.com> - 3.10.0-1
- Update to v3.10.0

* Thu Aug 31 2023 Mukundan Ragavan <nonamedotc@gmail.com> - 3.9.3-1
- Update to v3.9.3

* Sun Aug 13 2023 Mukundan Ragavan <nonamedotc@gmail.com> - 3.9.2-1
- Update to v3.9.2

* Tue Aug 08 2023 Mukundan Ragavan <nonamedotc@gmail.com> - 3.9.1-2
- drop i686 on F39+; inkscape (which is needed) dropped it on F39+

* Sun Aug 06 2023 Mukundan Ragavan <nonamedotc@gmail.com> - 3.9.1-1
- Update to v3.9.1

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 3.9.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sun Jun 18 2023 Mukundan Ragavan <nonamedotc@gmail.com> - 3.9.0-1
- Update to v3.9.0

* Wed May 24 2023 Mukundan Ragavan <nonamedotc@gmail.com> - 3.8.2-1
- Update to v3.8.2
